diff -r f6ef988fda71 trytond/ir/translation.py
--- a/trytond/ir/translation.py	Fri Sep 21 16:04:02 2012 +0200
+++ b/trytond/ir/translation.py	Sun Sep 23 17:30:03 2012 +0200
@@ -927,30 +944,30 @@
                 ):
             return False
         if model_name in pool.object_name_list():
-            model_obj = pool.get(model_name)
-            errors = model_obj._error_messages.values() + \
-                    model_obj._sql_error_messages.values()
-            for _, _, error in model_obj._sql_constraints:
+            Model = pool.get(model_name)
+            errors = Model._error_messages.values() + \
+                    Model._sql_error_messages.values()
+            for _, _, error in Model._sql_constraints:
                 errors.append(error)
             if translation.src not in errors:
                 return True
         elif model_name in pool.object_name_list(type='wizard'):
-            wizard_obj = pool.get(model_name, type='wizard')
-            errors = wizard_obj._error_messages.values()
+            Wizard = pool.get(model_name, type='wizard')
+            errors = Wizard._error_messages.values()
             if translation.src not in errors:
                 return True
         else:
             return True
 
-    def transition_clean(self, session):
+    def transition_clean(self):
         pool = Pool()
-        translation_obj = pool.get('ir.translation')
-        model_data_obj = pool.get('ir.model.data')
+        Translation = pool.get('ir.translation')
+        ModelData = pool.get('ir.model.data')
 
         to_delete = []
         keys = set()
-        translation_ids = translation_obj.search([])
-        for translation in translation_obj.browse(translation_ids):
+        translations = Translation.search([])
+        for translation in translations:
             if getattr(self, '_clean_%s' % translation.type)(translation):
                 to_delete.append(translation.id)
             elif translation.type in ('field', 'model', 'wizard_button',
@@ -962,46 +979,42 @@
                 else:
                     keys.add(key)
         # skip translation handled in ir.model.data
-        mdata_ids = model_data_obj.search([
+        models_data = ModelData.search([
             ('db_id', 'in', to_delete),
             ('model', '=', 'ir.translation'),
             ])
-        for mdata in model_data_obj.browse(mdata_ids):
+        for mdata in models_data:
             if mdata.db_id in to_delete:
                 to_delete.remove(mdata.db_id)
 
-        translation_obj.delete(to_delete)
+        Translation.delete(Translation.browse(to_delete))
         return 'succeed'
 
-TranslationClean()
-
 
 class TranslationUpdateStart(ModelView):
     "Update translation"
-    _name = 'ir.translation.update.start'
-    _description = __doc__
+    __name__ = 'ir.translation.update.start'
 
     language = fields.Many2One('ir.lang', 'Language', required=True,
         domain=[('translatable', '=', True)])
 
-    def default_language(self):
-        lang_obj = Pool().get('ir.lang')
+    @staticmethod
+    def default_language():
+        Lang = Pool().get('ir.lang')
         code = Transaction().context.get('language', False)
         try:
-            lang_id, = lang_obj.search([
+            lang, = Lang.search([
                     ('code', '=', code),
                     ('translatable', '=', True),
                     ], limit=1)
-            return lang_id
+            return lang.id
         except ValueError:
             return None
 
-TranslationUpdateStart()
-
 
 class TranslationUpdate(Wizard):
     "Update translation"
-    _name = "ir.translation.update"
+    __name__ = "ir.translation.update"
 
     start = StateView('ir.translation.update.start',
         'ir.translation_update_start_view_form', [
@@ -1010,14 +1023,15 @@
             ])
     update = StateAction('ir.act_translation_form')
 
-    def transition_update(self, session):
+    @staticmethod
+    def transition_update():
         return 'end'
 
-    def do_update(self, session, action):
+    def do_update(self, action):
         pool = Pool()
-        translation_obj = pool.get('ir.translation')
+        Translation = pool.get('ir.translation')
         cursor = Transaction().cursor
-        lang = session.start.language.code
+        lang = self.start.language.code
         cursor.execute('SELECT name, res_id, type, src, module ' \
                 'FROM ir_translation ' \
                 'WHERE lang=\'en_US\' ' \
@@ -1031,7 +1045,7 @@
                 (lang,))
         for row in cursor.dictfetchall():
             with Transaction().set_user(0):
-                translation_obj.create({
+                Translation.create({
                     'name': row['name'],
                     'res_id': row['res_id'],
                     'lang': lang,
@@ -1050,7 +1064,7 @@
                 (lang,))
         for row in cursor.dictfetchall():
             with Transaction().set_user(0):
-                translation_obj.create({
+                Translation.create({
                     'name': row['name'],
                     'res_id': row['res_id'],
                     'lang': lang,
@@ -1109,13 +1123,11 @@
         ])
         return action, {}
 
-TranslationUpdate()
-
 
 class TranslationExportStart(ModelView):
     "Export translation"
-    _name = 'ir.translation.export.start'
-    _description = __doc__
+    __name__ = 'ir.translation.export.start'
+
     language = fields.Many2One('ir.lang', 'Language', required=True,
         domain=[
             ('translatable', '=', True),
@@ -1126,33 +1138,30 @@
             ('state', 'in', ['installed', 'to upgrade', 'to remove']),
             ])
 
-    def default_language(self):
-        lang_obj = Pool().get('ir.lang')
+    @staticmethod
+    def default_language():
+        Lang = Pool().get('ir.lang')
         code = Transaction().context.get('language', False)
         try:
-            lang_id, = lang_obj.search([
+            lang, = Lang.search([
                     ('code', '=', code),
                     ('translatable', '=', True),
                     ], limit=1)
-            return lang_id
+            return lang.id
         except ValueError:
             return None
 
-TranslationExportStart()
-
 
 class TranslationExportResult(ModelView):
     "Export translation"
-    _description = __doc__
-    _name = 'ir.translation.export.result'
+    __name__ = 'ir.translation.export.result'
+
     file = fields.Binary('File', readonly=True)
 
-TranslationExportResult()
-
 
 class TranslationExport(Wizard):
     "Export translation"
-    _name = "ir.translation.export"
+    __name__ = "ir.translation.export"
 
     start = StateView('ir.translation.export.start',
         'ir.translation_export_start_view_form', [
@@ -1165,19 +1174,17 @@
             Button('Close', 'end', 'tryton-close'),
             ])
 
-    def transition_export(self, session):
+    def transition_export(self):
         pool = Pool()
-        translation_obj = pool.get('ir.translation')
-        file_data = translation_obj.translation_export(
-            session.start.language.code, session.start.module.name)
-        session.result.file = buffer(file_data)
+        Translation = pool.get('ir.translation')
+        file_data = Translation.translation_export(
+            self.start.language.code, self.start.module.name)
+        self.result.file = buffer(file_data)
         return 'result'
 
-    def default_result(self, session, fields):
-        file_ = session.result.file
-        session.result.file = False  # No need to store it in session
+    def default_result(self, fields):
+        file_ = self.result.file
+        self.result.file = False  # No need to store it in session
         return {
             'file': file_,
             }
-
-TranslationExport()
diff -r f6ef988fda71 trytond/ir/trigger.py
--- a/trytond/ir/trigger.py	Fri Sep 21 16:04:02 2012 +0200
+++ b/trytond/ir/trigger.py	Sun Sep 23 17:30:03 2012 +0200
@@ -11,11 +11,14 @@
 from ..cache import Cache
 from ..pool import Pool
 
+__all__ = [
+    'Trigger', 'TriggerLog',
+    ]
+
 
 class Trigger(ModelSQL, ModelView):
     "Trigger"
-    _name = 'ir.trigger'
-    _description = __doc__
+    __name__ = 'ir.trigger'
     name = fields.Char('Name', required=True, translate=True)
     active = fields.Boolean('Active', select=True)
     model = fields.Many2One('ir.model', 'Model', required=True, select=True)
@@ -48,41 +51,46 @@
         '0 for no delay.')
     action_model = fields.Many2One('ir.model', 'Action Model', required=True)
     action_function = fields.Char('Action Function', required=True)
+    _get_triggers_cache = Cache('ir_trigger.get_triggers')
 
-    def __init__(self):
-        super(Trigger, self).__init__()
-        self._sql_constraints += [
+    @classmethod
+    def __setup__(cls):
+        super(Trigger, cls).__setup__()
+        cls._sql_constraints += [
             ('on_exclusive',
                 'CHECK(NOT(on_time AND (on_create OR on_write OR on_delete)))',
                 '"On Time" and others are mutually exclusive!'),
         ]
-        self._constraints += [
+        cls._constraints += [
             ('check_condition', 'invalid_condition'),
         ]
-        self._error_messages.update({
+        cls._error_messages.update({
             'invalid_condition': 'Condition must be a python expression!',
         })
-        self._order.insert(0, ('name', 'ASC'))
+        cls._order.insert(0, ('name', 'ASC'))
 
-    def check_condition(self, ids):
+    @classmethod
+    def check_condition(cls, triggers):
         '''
         Check condition
         '''
-        for trigger in self.browse(ids):
+        for trigger in triggers:
             try:
                 compile(trigger.condition, '', 'eval')
             except (SyntaxError, TypeError):
                 return False
         return True
 
-    def default_active(self):
+    @staticmethod
+    def default_active():
         return True
 
-    def default_limit_number(self):
+    @staticmethod
+    def default_limit_number():
         return 0
 
-    def on_change_on_time(self, values):
-        if values.get('on_time'):
+    def on_change_on_time(self):
+        if self.on_time:
             return {
                     'on_create': False,
                     'on_write': False,
@@ -90,35 +98,31 @@
                     }
         return {}
 
-    def on_change_on_create(self, values):
-        if values.get('on_create'):
+    def on_change_on_create(self):
+        if self.on_create:
             return {
                     'on_time': False,
                     }
         return {}
 
-    def on_change_on_write(self, values):
-        if values.get('on_write'):
+    def on_change_on_write(self):
+        if self.on_write:
             return {
                     'on_time': False,
                     }
         return {}
 
-    def on_change_on_delete(self, values):
-        if values.get('on_delete'):
+    def on_change_on_delete(self):
+        if self.on_delete:
             return {
                     'on_time': False,
                     }
         return {}
 
-    @Cache('ir_trigger.get_triggers')
-    def get_triggers(self, model_name, mode):
+    @classmethod
+    def get_triggers(cls, model_name, mode):
         """
-        Return trigger ids for a model and a mode
-
-        :param model_name: the name of the model
-        :param mode: the mode that can be 'create', 'write', 'delete' or 'time'
-        :return: a list of ir.trigger ids
+        Return triggers for a model and a mode
         """
         assert mode in ['create', 'write', 'delete', 'time'], \
                 'Invalid trigger mode'
@@ -126,19 +130,22 @@
         if Transaction().user == 0:
             return []  # XXX is it want we want?
 
-        trigger_ids = self.search([
-            ('model.model', '=', model_name),
-            ('on_%s' % mode, '=', True),
-            ])
-        return trigger_ids
+        key = (model_name, mode)
+        trigger_ids = cls._get_triggers_cache.get(key)
+        if trigger_ids is not None:
+            return cls.browse(trigger_ids)
 
-    def eval(self, trigger, record):
+        triggers = cls.search([
+                ('model.model', '=', model_name),
+                ('on_%s' % mode, '=', True),
+                ])
+        cls._get_triggers_cache.set(key, map(int, triggers))
+        return triggers
+
+    @staticmethod
+    def eval(trigger, record):
         """
         Evaluate the condition of trigger
-
-        :param trigger: a BrowseRecord of ir.trigger
-        :param record: a BrowseRecord of the tested model
-        :return: a boolean
         """
         env = {}
         env['current_date'] = datetime.datetime.today()
@@ -147,18 +154,16 @@
         env['self'] = record
         return bool(safe_eval(trigger.condition, env))
 
-    def trigger_action(self, ids, trigger_id):
+    @classmethod
+    def trigger_action(cls, records, trigger):
         """
-        Trigger the action define on trigger_id for the ids
-
-        :param ids: the list of record ids triggered
-        :param trigger_id: the trigger id
+        Trigger the action define on trigger for the records
         """
         pool = Pool()
-        trigger_log_obj = pool.get('ir.trigger.log')
-        trigger = self.browse(trigger_id)
-        model_obj = pool.get(trigger.action_model.model)
+        TriggerLog = pool.get('ir.trigger.log')
+        Model = pool.get(trigger.action_model.model)
         cursor = Transaction().cursor
+        ids = map(int, records)
 
         # Filter on limit_number
         if trigger.limit_number:
@@ -169,7 +174,7 @@
                 cursor.execute('SELECT "record_id", COUNT(1) FROM "%s" '
                         'WHERE %s AND "trigger" = %%s '
                         'GROUP BY "record_id"'
-                        % (trigger_log_obj._table, red_sql),
+                        % (TriggerLog._table, red_sql),
                         red_ids + [trigger.id])
                 number = dict(cursor.fetchall())
                 for record_id in sub_ids:
@@ -190,7 +195,7 @@
                         'FROM "%s" '
                         'WHERE %s AND "trigger" = %%s '
                         'GROUP BY "record_id"'
-                        % (trigger_log_obj._table, red_sql),
+                        % (TriggerLog._table, red_sql),
                         red_ids + [trigger.id])
                 delay = dict(cursor.fetchall())
                 for record_id in sub_ids:
@@ -214,66 +219,66 @@
                         new_ids.append(record_id)
             ids = new_ids
 
-        if ids:
-            getattr(model_obj, trigger.action_function)(ids, trigger_id)
+        records = Model.browse(ids)
+        if records:
+            getattr(Model, trigger.action_function)(records, trigger)
         if trigger.limit_number or trigger.minimum_delay:
-            for record_id in ids:
-                trigger_log_obj.create({
+            for record in records:
+                TriggerLog.create({
                     'trigger': trigger.id,
-                    'record_id': record_id,
+                    'record_id': record.id,
                     })
 
-    def trigger_time(self):
+    @classmethod
+    def trigger_time(cls):
         '''
         Trigger time actions
         '''
         pool = Pool()
-        trigger_ids = self.search([
-            ('on_time', '=', True),
-            ])
-        for trigger in self.browse(trigger_ids):
-            model_obj = pool.get(trigger.model.model)
-            triggered_ids = []
+        triggers = cls.search([
+                ('on_time', '=', True),
+                ])
+        for trigger in triggers:
+            Model = pool.get(trigger.model.model)
+            triggered = []
             # TODO add a domain
-            record_ids = model_obj.search([])
-            for record in model_obj.browse(record_ids):
-                if self.eval(trigger, record):
-                    triggered_ids.append(record.id)
-            if triggered_ids:
-                self.trigger_action(triggered_ids, trigger.id)
+            records = Model.search([])
+            for record in records:
+                if cls.eval(trigger, record):
+                    triggered.append(record)
+            if triggered:
+                cls.trigger_action(triggered, trigger)
 
-    def create(self, values):
-        res = super(Trigger, self).create(values)
+    @classmethod
+    def create(cls, values):
+        res = super(Trigger, cls).create(values)
         # Restart the cache on the get_triggers method of ir.trigger
-        self.get_triggers.reset()
+        cls._get_triggers_cache.clear()
         return res
 
-    def write(self, ids, values):
-        res = super(Trigger, self).write(ids, values)
+    @classmethod
+    def write(cls, ids, values):
+        res = super(Trigger, cls).write(ids, values)
         # Restart the cache on the get_triggers method of ir.trigger
-        self.get_triggers.reset()
+        cls._get_triggers_cache.clear()
         return res
 
-    def delete(self, ids):
-        res = super(Trigger, self).delete(ids)
+    @classmethod
+    def delete(cls, records):
+        super(Trigger, cls).delete(records)
         # Restart the cache on the get_triggers method of ir.trigger
-        self.get_triggers.reset()
-        return res
-
-Trigger()
+        cls._get_triggers_cache.clear()
 
 
 class TriggerLog(ModelSQL):
     'Trigger Log'
-    _name = 'ir.trigger.log'
-    _description = __doc__
+    __name__ = 'ir.trigger.log'
     trigger = fields.Many2One('ir.trigger', 'Trigger', required=True)
     record_id = fields.Integer('Record ID', required=True)
 
-    def init(self, module_name):
-        super(TriggerLog, self).init(module_name)
+    @classmethod
+    def __register__(cls, module_name):
+        super(TriggerLog, cls).__register__(module_name)
 
-        table = TableHandler(Transaction().cursor, self, module_name)
+        table = TableHandler(Transaction().cursor, cls, module_name)
         table.index_action(['trigger', 'record_id'], 'add')
-
-TriggerLog()
diff -r f6ef988fda71 trytond/ir/ui/__init__.py
--- a/trytond/ir/ui/__init__.py	Fri Sep 21 16:04:02 2012 +0200
+++ b/trytond/ir/ui/__init__.py	Sun Sep 23 17:30:03 2012 +0200
@@ -1,5 +1,2 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
-from .menu import *
-from .view import *
-from .icon import *
diff -r f6ef988fda71 trytond/ir/ui/icon.py
--- a/trytond/ir/ui/icon.py	Fri Sep 21 16:04:02 2012 +0200
+++ b/trytond/ir/ui/icon.py	Sun Sep 23 17:30:03 2012 +0200
@@ -6,12 +6,16 @@
 from trytond.model import ModelView, ModelSQL, fields
 from trytond.tools import file_open
 from trytond.transaction import Transaction
+from trytond.rpc import RPC
+
+__all__ = [
+    'Icon',
+    ]
 
 
 class Icon(ModelSQL, ModelView):
     'Icon'
-    _name = 'ir.ui.icon'
-    _description = __doc__
+    __name__ = 'ir.ui.icon'
 
     name = fields.Char('Name', required=True, select=True)
     module = fields.Char('Module', readonly=True, required=True)
@@ -19,33 +23,32 @@
     icon = fields.Function(fields.Char('Icon', depends=['path']), 'get_icon')
     sequence = fields.Integer('Sequence', required=True)
 
-    def __init__(self):
-        super(Icon, self).__init__()
-        self._order.insert(0, ('sequence', 'ASC'))
-        self._rpc.update({
-            'list_icons': False,
-        })
+    @classmethod
+    def __setup__(cls):
+        super(Icon, cls).__setup__()
+        cls._order.insert(0, ('sequence', 'ASC'))
+        cls.__rpc__.update({
+                'list_icons': RPC(),
+                })
 
-    def default_module(self):
+    @staticmethod
+    def default_module():
         return Transaction().context.get('module') or ''
 
-    def default_sequence(self):
+    @staticmethod
+    def default_sequence():
         return 10
 
-    def list_icons(self):
+    @classmethod
+    def list_icons(cls):
         icons = {}
-        for icon in self.browse(self.search([],
+        for icon in cls.browse(cls.search([],
                 order=[('sequence', 'ASC'), ('id', 'ASC')])):
             if icon.name not in icons:
                 icons[icon.name] = icon.id
         return sorted((icon_id, name) for name, icon_id in icons.iteritems())
 
-    def get_icon(self, ids, name):
-        result = {}
-        for icon in self.browse(ids):
-            path = os.path.join(icon.module, icon.path.replace('/', os.sep))
-            with file_open(path, subdir='modules') as fp:
-                result[icon.id] = fp.read()
-        return result
-
-Icon()
+    def get_icon(self, name):
+        path = os.path.join(self.module, self.path.replace('/', os.sep))
+        with file_open(path, subdir='modules') as fp:
+            return fp.read()
diff -r f6ef988fda71 trytond/ir/ui/menu.py
--- a/trytond/ir/ui/menu.py	Fri Sep 21 16:04:02 2012 +0200
+++ b/trytond/ir/ui/menu.py	Sun Sep 23 17:30:03 2012 +0200
@@ -4,6 +4,10 @@
 from trytond.transaction import Transaction
 from trytond.pool import Pool
 
+__all__ = [
+    'UIMenu',
+    ]
+
 
 def one_in(i, j):
     """Check the presence of an element of setA in setB
@@ -64,8 +68,8 @@
 
 class UIMenu(ModelSQL, ModelView):
     "UI menu"
-    _name = 'ir.ui.menu'
-    _description = __doc__
+    __name__ = 'ir.ui.menu'
+
     name = fields.Char('Menu', required=True, translate=True)
     sequence = fields.Integer('Sequence', required=True)
     childs = fields.One2Many('ir.ui.menu', 'parent', 'Children')
@@ -86,56 +90,51 @@
                 ]), 'get_action', setter='set_action')
     active = fields.Boolean('Active')
 
-    def __init__(self):
-        super(UIMenu, self).__init__()
-        self._order.insert(0, ('sequence', 'ASC'))
-        self._constraints += [
+    @classmethod
+    def __setup__(cls):
+        super(UIMenu, cls).__setup__()
+        cls._order.insert(0, ('sequence', 'ASC'))
+        cls._constraints += [
             ('check_recursion', 'recursive_menu'),
             ('check_name', 'wrong_name'),
         ]
-        self._error_messages.update({
+        cls._error_messages.update({
             'recursive_menu': 'You can not create recursive menu!',
             'wrong_name': 'You can not use "%s" in name field!' % SEPARATOR,
         })
 
-    def default_icon(self):
+    @staticmethod
+    def default_icon():
         return 'tryton-open'
 
-    def default_sequence(self):
+    @staticmethod
+    def default_sequence():
         return 10
 
-    def default_active(self):
+    @staticmethod
+    def default_active():
         return True
 
-    def list_icons(self):
+    @staticmethod
+    def list_icons():
         pool = Pool()
-        icon_obj = pool.get('ir.ui.icon')
+        Icon = pool.get('ir.ui.icon')
         return sorted(CLIENT_ICONS
-            + [(name, name) for _, name in icon_obj.list_icons()])
+            + [(name, name) for _, name in Icon.list_icons()])
 
-    def check_name(self, ids):
-        for menu in self.browse(ids):
-            if SEPARATOR in menu.name:
-                return False
+    def check_name(self):
+        if SEPARATOR in self.name:
+            return False
         return True
 
-    def get_rec_name(self, ids, name):
-        if not ids:
-            return {}
-        res = {}
+    def get_rec_name(self, name):
+        if self.parent:
+            return self.parent.get_rec_name(name) + SEPARATOR + self.name
+        else:
+            return self.name
 
-        def _name(menu):
-            if menu.id in res:
-                return res[menu.id]
-            elif menu.parent:
-                return _name(menu.parent) + SEPARATOR + menu.name
-            else:
-                return menu.name
-        for menu in self.browse(ids):
-            res[menu.id] = _name(menu)
-        return res
-
-    def search_rec_name(self, name, clause):
+    @classmethod
+    def search_rec_name(cls, name, clause):
         if isinstance(clause[2], basestring):
             values = clause[2].split(SEPARATOR)
             values.reverse()
@@ -144,85 +143,81 @@
             for name in values:
                 domain.append((field, clause[1], name))
                 field = 'parent.' + field
-            ids = self.search(domain, order=[])
+            ids = cls.search(domain, order=[])
             return [('id', 'in', ids)]
         #TODO Handle list
         return [('name',) + tuple(clause[1:])]
 
-    def search(self, domain, offset=0, limit=None, order=None, count=False,
+    @classmethod
+    def search(cls, domain, offset=0, limit=None, order=None, count=False,
             query_string=False):
-        res = super(UIMenu, self).search(domain, offset=offset, limit=limit,
+        menus = super(UIMenu, cls).search(domain, offset=offset, limit=limit,
                 order=order, count=False, query_string=query_string)
         if query_string:
-            return res
+            return menus
 
-        if res:
-            menus = self.browse(res)
+        if menus:
             parent_ids = [x.parent.id for x in menus if x.parent]
-            parent_ids = self.search([
-                ('id', 'in', parent_ids),
-                ])
-            res = [x.id for x in menus
-                    if (x.parent.id in parent_ids) or not x.parent]
+            parents = cls.search([
+                    ('id', 'in', parent_ids),
+                    ])
+            menus = [x for x in menus
+                if (x.parent and x.parent in parents) or not x.parent]
 
         if count:
-            return len(res)
-        return res
+            return len(menus)
+        return menus
 
-    def get_action(self, ids, name):
+    @classmethod
+    def get_action(cls, menus, name):
         pool = Pool()
-        action_keyword_obj = pool.get('ir.action.keyword')
-        res = {}
-        for menu_id in ids:
-            res[menu_id] = None
+        ActionKeyword = pool.get('ir.action.keyword')
+        actions = dict((m.id, None) for m in menus)
         with Transaction().set_context(active_test=False):
-            action_keyword_ids = action_keyword_obj.search([
-                ('keyword', '=', 'tree_open'),
-                ('model', 'in', [self._name + ',' + str(x) for x in ids]),
-                ])
-        for action_keyword in action_keyword_obj.browse(action_keyword_ids):
-            model_id = int(
-                action_keyword.model.split(',')[1].split(',')[0].strip('('))
-            action_obj = pool.get(action_keyword.action.type)
+            action_keywords = ActionKeyword.search([
+                    ('keyword', '=', 'tree_open'),
+                    ('model', 'in', [str(m) for m in menus]),
+                    ])
+        for action_keyword in action_keywords:
+            model = action_keyword.model
+            Action = pool.get(action_keyword.action.type)
             with Transaction().set_context(active_test=False):
-                action_id = action_obj.search([
-                    ('action', '=', action_keyword.action.id),
-                    ])
-            if action_id:
-                action_id = action_id[0]
+                factions = Action.search([
+                        ('action', '=', action_keyword.action.id),
+                        ], limit=1)
+            if factions:
+                action, = factions
             else:
-                action_id = 0
-            res[model_id] = action_keyword.action.type + ',' + str(action_id)
-        return res
+                action = '%s,0' % action_keyword.action.type
+            actions[model.id] = str(action)
+        return actions
 
-    def set_action(self, ids, name, value):
+    @classmethod
+    def set_action(cls, menus, name, value):
         if not value:
             return
         pool = Pool()
-        action_keyword_obj = pool.get('ir.action.keyword')
-        action_keyword_ids = []
+        ActionKeyword = pool.get('ir.action.keyword')
+        action_keywords = []
         cursor = Transaction().cursor
-        for i in range(0, len(ids), cursor.IN_MAX):
-            sub_ids = ids[i:i + cursor.IN_MAX]
-            action_keyword_ids += action_keyword_obj.search([
+        for i in range(0, len(menus), cursor.IN_MAX):
+            sub_menus = menus[i:i + cursor.IN_MAX]
+            action_keywords += ActionKeyword.search([
                 ('keyword', '=', 'tree_open'),
-                ('model', 'in', [self._name + ',' + str(menu_id)
-                    for menu_id in sub_ids]),
+                ('model', 'in', [str(menu) for menu in sub_menus]),
                 ])
-        if action_keyword_ids:
+        if action_keywords:
             with Transaction().set_context(_timestamp=False):
-                action_keyword_obj.delete(action_keyword_ids)
+                ActionKeyword.delete(action_keywords)
         action_type, action_id = value.split(',')
         if not int(action_id):
             return
-        action_obj = pool.get(action_type)
-        action = action_obj.browse(int(action_id))
-        for menu_id in ids:
+        Action = pool.get(action_type)
+        action = Action(int(action_id))
+        for menu in menus:
             with Transaction().set_context(_timestamp=False):
-                action_keyword_obj.create({
+                ActionKeyword.create({
                     'keyword': 'tree_open',
-                    'model': self._name + ',' + str(menu_id),
+                    'model': str(menu),
                     'action': action.action.id,
                     })
-
-UIMenu()
